
import java.util.*;
import java.awt.*;

public class Level
{
	private String author;
	private String name;
	private String comment;

	private Stone [] [] stone_map;

	public Level ()
	{
		stone_map = new Stone [C_LevelEditor.number_of_lines] [C_LevelEditor.number_of_cols];
	}

	public void setLine (String line, int line_index)
	{
		char [] entrys = line.toCharArray();

		for (int i = 0; i < C_LevelEditor.number_of_cols; i++)
		{
			Stone stone = null;

			if (entrys[i] == 'r')
			{
				stone = new Stone (line_index, i, Color.red);
			}
			else if (entrys[i] == 'b')
			{
				stone = new Stone (line_index, i, Color.blue);
			}
			else if (entrys[i] == 'g')
			{
				stone = new Stone (line_index, i, Color.green);
			}
			else if (entrys[i] == 'y')
			{
				stone = new Stone (line_index, i, Color.yellow);
			}
			else if (entrys[i] == ':')
			{
				// do nothing
			}
			else
			{
				// do nothing
			}


			// Store stone in array
			if (stone == null)
			{
				// do nothing
			}
			else
			{
				stone_map [line_index] [i] = stone;
			}
		}
	}

	public void setAuthor (String author)
	{
		this.author = author;
	}

	public void setName (String name)
	{
		this.name = name;
	}

	public void setComment (String comment)
	{
		this.comment = comment;
	}

	public void paintLevel (Graphics g)
	{
		for (int i = 0; i < stone_map.length; i++)
		{
			for (int j = 0; j < stone_map[i].length; j++)
			{
				Stone stone = stone_map [i][j];

				if (stone == null)
				{
					// draw nothing
				}
				else
				{
					stone.drawStone (g);
				}
			}
		}

		g.setColor (Color.yellow);

		g.drawString (comment, 50, 250);
		g.drawString (name, 50, 270);
		g.drawString (author, 50, 290);
	}
}