import java.awt.*;
import java.applet.*;

public class Level
{
	// Variablen
	private char [] [] level_array;
	private Snake snake;
	private int last_i;
	private int last_j;
	public boolean changed;

	public Level (Snake snake)
	{
		this.snake = snake;
		level_array = new char [40] [40];
		initializeLevel();

		changed = false;
	}

	public void initializeLevel ()
	{
		for (int i = 0; i < level_array.length; i++)
		{
			for (int j = 0; j < level_array[i].length; j++)
			{
				level_array [i] [j] = ':';
			}
		}
	}

	public void changeLevelArray (int head_i, int head_j, int kill_i, int kill_j)
	{
		if (level_array [head_i] [head_j] == 's')
		{
			level_array [head_i] [head_j] = 's';
			level_array [kill_i] [kill_j] = ':';
			last_i = kill_i;
			last_j = kill_j;
			changed = true;
		}
		else
		{
			level_array [head_i] [head_j] = 's';
			level_array [kill_i] [kill_j] = ':';
			last_i = kill_i;
			last_j = kill_j;
			changed = false;
		}
	}

	public void paintLevel (Graphics g)
	{
		for (int i = 0; i < level_array.length; i++)
		{
			for (int j = 0; j < level_array[i].length; j++)
			{
				if (i == last_i && j == last_j)
				{
					g.setColor (Color.black);
					g.fillOval (j*14 , i*14 , 14, 14);
				}
				else if (level_array[i][j] == 's')
				{
					g.setColor (Color.blue);
					g.fillOval (j*14 , i*14 , 14, 14);
				}
				else if (level_array [i] [j] == 'r')
				{
					g.setColor (Color.red);
					g.fillRect (j*14, i*14, 14, 14);
				}
				else
				{
					// do nothing
				}
			}
		}
	}
}