import java.applet.*;
import java.awt.*;
import java.util.*;

public class Main extends Applet implements Runnable
{
	// Konstanten
	private static final String total_levels = "Levels_in_total";

	// Initialisierung der Variablen
	private int speed;				// Spielgeschwindigkeit
	private int level_number; 		// Nummer des aktuellen Levels
	private int levels_in_total;	// Gesamtanzahl der Level

	// Levelvektor
	private Level [] level_array;

	// Spielthread
	Thread th;

	// LevelReader Objectrefferenz
	LevelReader reader;

	// Aktuelles Level
	Level level;

	// Variablen fr die Doppelpufferung
	private Image dbImage;
	private Graphics dbg;


	public void init()
	{
		// Initialisierung der Spielgeschwindigkeit
		speed = 20;

		// Initialisierung der aktuellen Level Nummer
		level_number = 0;

		// Setzten der Hintergrundfarbe
		setBackground (Color.black);

		// Initialisierung des Readers
		reader = new LevelReader (this);

		// Initialisierung des Levelvectors
		level_array = reader.readLevels();

		// Initialisierung des aktuellen Levels
		level = level_array [0];

		// Initialisierung der Gesamtanzahl von Leveln
		levels_in_total = Integer.parseInt (getParameter (C_LevelEditor.total_levels));
	}

	public void start ()
	{
		// Schaffen eines neuen Threads, in dem das Spiel luft
		th = new Thread (this);
		// Starten des Threads
		th.start ();
	}

	public void stop()
	{
		th.stop();
	}

	public void destroy()
	{

	}

	// Erhhen oder erniedrigen des Levels mit den Cursortasten
	public boolean keyDown (Event e, int key)
	{
		if (key == Event.LEFT)
		{
			if (level_number > 0)
			{
				level_number --;
				level = level_array [level_number];
			}
		}
		else if (key == Event.RIGHT)
		{
			if (level_number < levels_in_total)
			{
				level_number ++;
				level = level_array [level_number];
			}
		}

		return true;
	}

	public void run ()
	{
		// Erniedrigen der ThreadPriority um zeichnen zu erleichtern
		Thread.currentThread().setPriority(Thread.MIN_PRIORITY);

		// Solange true ist luft der Thread weiter
		while (true)
		{

			// Neuzeichnen des Applets
			repaint();

			try
			{
				// Stoppen des Threads fr in Klammern angegebene Millisekunden
				Thread.sleep (speed);
			}
			catch (InterruptedException ex)
			{
				// do nothing
			}

			// Zurcksetzen der ThreadPriority auf Maximalwert
			Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
		}
	}


	public void paint (Graphics g)
	{
		level.paintLevel (g);
	}

	/** Update - Methode, Realisierung der Doppelpufferung zur Reduzierung
	des Bildschirmflackerns */
	public void update (Graphics g)
	{
		// Initialisierung des DoubleBuffers
		if (dbImage == null)
		{
			dbImage = createImage (this.getSize().width, this.getSize().height);
			dbg = dbImage.getGraphics ();
		}

		// Bildschirm im Hintergrund lschen
		dbg.setColor (getBackground ());
		dbg.fillRect (0, 0, this.getSize().width, this.getSize().height);

		// Auf gelschten Hintergrund Vordergrund zeichnen
		dbg.setColor (getForeground());
		paint (dbg);

		// Nun fertig gezeichnetes Bild Offscreen auf dem richtigen Bildschirm anzeigen
		g.drawImage (dbImage, 0, 0, this);
	}


}
