import java.applet.*;
import java.awt.*;
import java.util.*;

public class Main extends Applet implements Runnable
{
	// Initialisierung der Variablen
	private Thread th;
	private Level level;
	private Snake snake;

	private Image dbImage;
	private Graphics dbg;

	// gibt an, ob seit dem letzten Move schon ein Keykommando ausgefhrt wurde
	private boolean key_blocked;

	public void init()
	{
		setBackground (Color.black);

		snake = new Snake();
		level = new Level(snake);
		snake.setLevel (level);
	}

	public void start ()
	{
		// Schaffen eines neuen Threads, in dem das Spiel luft
		th = new Thread (this);
		// Starten des Threads
		th.start ();
	}

	public void run ()
	{
		// Erniedrigen der ThreadPriority um zeichnen zu erleichtern
		Thread.currentThread().setPriority(Thread.MIN_PRIORITY);

		// Solange true ist luft der Thread weiter
		while (true)
		{
			snake.moveSnake();
			key_blocked = false;

			// Neuzeichnen des Applets
			repaint();

			try
			{
				// Stoppen des Threads fr in Klammern angegebene Millisekunden
				Thread.sleep (200);
			}
			catch (InterruptedException ex)
			{
				// do nothing
			}

			// Zurcksetzen der ThreadPriority auf Maximalwert
			Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
		}
	}

	public boolean keyDown (Event e, int key)
	{
		if (key == Event.DOWN && snake.y_speed != -1 && !key_blocked)
		{
			snake.x_speed = 0;
			snake.y_speed = 1;
			key_blocked = true;
		}
		else if (key == Event.UP && snake.y_speed != 1 && !key_blocked)
		{
			snake.x_speed = 0;
			snake.y_speed = -1;
			key_blocked = true;
		}
		else if (key == Event.LEFT && snake.x_speed != 1 && !key_blocked)
		{
			snake.x_speed = -1;
			snake.y_speed = 0;
			key_blocked = true;
		}
		else if (key == Event.RIGHT && snake.x_speed != -1 && !key_blocked)
		{
			snake.x_speed = 1;
			snake.y_speed = 0;
			key_blocked = true;
		}
		else if (key == 32)
		{
			snake.resizeSnake();
		}

		return true;
	}

	public void update (Graphics g)
	{
		if (level.changed)
		{
			update2(g);
		}
		else
		{
			paint (g);
		}
	}


	public void stop()
	{

	}

	public void destroy()
	{

	}



	/** Update - Methode, Realisierung der Doppelpufferung zur Reduzierung des Bildschirmflackerns */
	public void update2 (Graphics g)
	{
		// Initialisierung des DoubleBuffers
		if (dbImage == null)
		{
			dbImage = createImage (this.getSize().width, this.getSize().height);
			dbg = dbImage.getGraphics ();
		}

		// Bildschirm im Hintergrund lschen
		dbg.setColor (getBackground ());
		dbg.fillRect (0, 0, this.getSize().width, this.getSize().height);

		// Auf gelschten Hintergrund Vordergrund zeichnen
		dbg.setColor (getForeground());
		paint (dbg);

		// Nun fertig gezeichnetes Bild Offscreen auf dem richtigen Bildschirm anzeigen
		g.drawImage (dbImage, 0, 0, this);
	}

	public void paint (Graphics g)
	{
		level.paintLevel(g);
	}
}

