import java.awt.*;
import java.applet.*;

public class Main extends Applet implements Runnable
{
	// Variablen
	private int speed;
	private int scroll_speed;
	private int game_position;
	private int left_border;
	private int right_border;

	private Star [] stars;
	private Ufo ufo;

	// Spielthread
	Thread th;

	// Variablen fr die Doppelpufferung
	private Image dbImage;
	private Graphics dbg;

	public void init()
	{
		setBackground(Color.black);

		// Initialisierung der Variablen
		speed = 20;
		scroll_speed = 0;
		game_position = 300;
		left_border = -150;
		right_border = 440;

		fillStarArray();

		ufo = new Ufo(getImage(getCodeBase (),"Ufo1.gif"), this);
	}

	public void start()
	{
		// Schaffen eines neuen Threads, in dem das Spiel luft
		th = new Thread(this);
		// Starten des Threads
		th.start ();

	}

	public void stop()
	{
		// Thread stoppen
		th.stop();
		// Thread auf null setzen
		th = null;
	}

	public boolean mouseMove(Event e, int x, int y)
	{
		if (x < 50)
		{
			scroll_speed = 1;
		}
		else if (x < 25)
		{
			scroll_speed = 2;
		}
		else if (x > 250)
		{
			scroll_speed = -1;
		}
		else if (x > 275)
		{
			scroll_speed = -2;
		}
		else
		{
			scroll_speed = 0;
		}

		return true;
	}

	public void run()
	{
		// Erniedrigen der ThreadPriority um zeichnen zu erleichtern
		Thread.currentThread().setPriority(Thread.MIN_PRIORITY);

		// Solange true ist luft der Thread weiter
		while (true)
		{

			if ( game_position <= 150 && scroll_speed > 0)
			{
				scroll_speed = 0;
			}
			else if (game_position >= 450 && scroll_speed < 0)
			{
				scroll_speed = 0;
			}

			if (scroll_speed != 0)
			{
				scrollGame();
			}

			ufo.moveUfo();

			// Neuzeichnen des Applets
			repaint();

			try
			{
				// Stoppen des Threads fr in Klammern angegebene Millisekunden
				Thread.sleep (speed);
			}
			catch (InterruptedException ex)
			{
				// do nothing
			}

			// Zurcksetzen der ThreadPriority auf Maximalwert
			Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
		}

	}

	private void fillStarArray()
	{
		// Sternenarray initialisieren
		stars = new Star[300];

		// Vorzeichen -
		for(int i=0; i<100; i++)
		{
			// Neuen Stern erzeugen
			Star star = new Star(i, -1);
			// in Sternenarray speichern
			stars[i] = star;
		}

		// Vorzeichen -
		for(int i=100; i<300; i++)
		{
			// Neuen Stern erzeugen
			Star star = new Star((300 - 2*i), 1);
			// in Sternenarray speichern
			stars[i] = star;
		}
	}

	public void scrollGame()
	{
		// Sterne bewegen
		for(int i=0; i<stars.length; i++)
		{
			Star star = stars[i];

			star.scrollStar(scroll_speed);

			int x_pos_star = star.getXPos();

			if (x_pos_star < 0 || x_pos_star > 300)
			{
				star.setInSight(false);
			}
			else
			{
				star.setInSight(true);
			}
		}

		ufo.scrollUfo(scroll_speed);

		game_position -= scroll_speed;
		left_border += scroll_speed;
		right_border += scroll_speed;
	}


	/** Update - Methode, Realisierung der Doppelpufferung zur Reduzierung des Bildschirmflackerns */
	public void update (Graphics g)
	{
		// Initialisierung des DoubleBuffers
		if (dbImage == null)
		{
			dbImage = createImage (this.getSize().width, this.getSize().height);
			dbg = dbImage.getGraphics ();
		}

		// Bildschirm im Hintergrund lschen
		dbg.setColor (getBackground ());
		dbg.fillRect (0, 0, this.getSize().width, this.getSize().height);

		// Auf gelschten Hintergrund Vordergrund zeichnen
		dbg.setColor (getForeground());
		paint (dbg);

		// Nun fertig gezeichnetes Bild Offscreen auf dem richtigen Bildschirm anzeigen
		g.drawImage (dbImage, 0, 0, this);
	}

	public void paint(Graphics g)
	{
		// Sterne zeichnen
		for(int i=0; i<stars.length; i++)
		{
			stars[i].paintStar(g);
		}

		ufo.paintUfo(g);

		g.setColor(Color.blue);
		g.fillRect(left_border, 0, 10, 300);
		g.fillRect(right_border, 0, 10, 300);

		g.setColor(Color.green);
		g.drawString("Game position: " + game_position, 20,20);
		g.drawString("Left border: " + left_border, 20, 40);
		g.drawString("Right border: " + (right_border + 10), 20, 60);
	}
}